namespace :db do
  desc "Create a new PE console user"
  task :create_user => :connect do
    usage_string = 'Usage: rake db:create_new_user EMAIL="foo@bar.com" PASSWORD="123@#$%^&*()-_+=,?[}{]abc" ROLE="Read-Only|Read-Write|Admin"'
    email = ENV['EMAIL']
    password = ENV['PASSWORD']
    role = Role.find_by_name(ENV['ROLE'])
    if email.nil?
      puts "Missing EMAIL parameter."
      puts usage_string
    elsif password.nil?
      puts "Missing PASSWORD parameter."
      puts usage_string
    elsif role.nil?
      puts "Missing or invalid ROLE parameter."
      puts usage_string
    else
      new_user = User.new do |u|
        u.email = email
        u.password = if password.length >= 2 and password.start_with? "'" and password.end_with? "'"
                       password[1..-2]
                     else
                       password
                     end
        u.roles = [role]
        u.status = "enabled"
      end
      new_user.save!
    end
  end
end
