class PuppetEnterpriseConsole.Node extends Batman.Model
  @global true

  @persist Batman.RestStorage
  @url = '/lm/nodes'
  @primaryKey = 'name'
  @encode 'name'

  @on 'loading', -> setTimeout (=> @set('batmanState', 'loading')), 0
  @on 'loaded', -> setTimeout (=> @set('batmanState', 'loaded')), 0

  @classAccessor 'filtered', ->
    load = (set) =>
      @unset('loadingError')
      @load (@get('filters') || {}), (error, data) =>
        if error
          @set('loadingError', error)
          @fire('loaded')
        else
          node.set('isSelected', yes) for node in data
          set.add data...
      return set

    load new Batman.Set()

  @classAccessor 'selected', ->
    @get('filtered').filter (node) -> node.get('isSelected')

  @classAccessor 'nodeSetID', ->
    key = null
    $.ajax '/lm/nodeset'
      async: false
      type: 'POST'
      data: { nodes: @get('selected').map (n) -> n.get('name') }
      success: (data) =>
        key = data
    return key

  @validateAndGetNodeSetID: ->
    key = @get('nodeSetID')
    $.ajax '/lm/nodeset'
      async: false
      type: 'HEAD'
      data: { key }
      statusCode: { 400: => @property('selected').fire() }
    @get('nodeSetID')

  for name, value of { selectAll: yes, selectNone: no }
    do (name, value) =>
      @[name] = ->
        @property('selected').isolate()
        @get('filtered').forEach (node) -> node.set('isSelected', value)
        @property('selected').expose()
        @property('selected').fire()

  toggleSelected: -> @set('isSelected', not @get('isSelected'))
